<template>
  <div id="sw-register-modal" data-testid="register-modal">
    <SfModal
      class="sw-modal"
      :title="modalTitle"
      :visible="isModalOpen"
      @close="toggleModal"
    >
      <transition name="fade" mode="out-in">
        <div class="sw-register-modal__wrapper">
          <SwRegister
            class="register__component"
            @success="toggleModal"
          />
          <div class="smartphone-only bottom bottom__close">
            <SwButton
              class="
                sf-button
                sf-select__cancel
                sf-button--full-width
                close-button
                color-secondary
              "
              @click="toggleModal()"
              data-testid="toggle-modal-button"
            >
              {{ $t("Cancel") }}
            </SwButton>
          </div>
        </div>
      </transition>
    </SfModal>
  </div>
</template>

<script>
import { SfHeading, SfModal, SfAlert } from "@storefront-ui/vue"
import { useUser, useUIState } from "@shopware-pwa/composables"
import SwButton from "@/components/atoms/SwButton.vue"
const SwLogin = () => import("@/components/SwLogin.vue")
const SwRegister = () => import("@/components/SwRegister.vue")
const SwResetPassword = () => import("@/components/SwResetPassword.vue")

export default {
  name: "SwLoginModal",
  components: {
    SfAlert,
    SwButton,
    SfHeading,
    SfModal,
    SwLogin,
    SwRegister,
    SwResetPassword,
  },
  props: {
    onClose: {
      type: Function,
      default: undefined,
    },
    onSuccess: {
      type: Function,
      default: undefined,
    },
  },
  setup(props, { root }) {
    const { loading, error } = useUser()
    const { isOpen, switchState } = useUIState({
      stateName: "REGISTER_MODAL_STATE",
    })

    return {
      isLoading: loading,
      toggleModal: switchState,
      isModalOpen: isOpen,
      error,
    }
  },
  data() {
    return {
      key: "modal-opened",
    }
  },
  computed: {
    modalTitle() {
      return this.$t("Register")
    },
  },
  watch: {
    isModalOpen: {
      handler(oldVal, newVal) {
        if (oldVal === true) {
          // enforce rerender dynamic component
          this.key = "modal-closed"
          return
        }
        this.key = "modal-opened"
      },
    },
  },
  methods: {
    closeHandler() {
      ;(typeof this.onClose !== "undefined" && this.onClose()) ||
        this.isModalOpen()
    },
  },
}
</script>

<style lang="scss" scoped>
@import "@/assets/scss/variables";

#sw-register-modal {
  box-sizing: border-box;
  --modal-index: 100;
  @include for-desktop {
    & > * {
      --modal-width: unset;
      --modal-content-padding: var(--spacer-xl) var(--spacer-base);
    }
    ::v-deep .sf-modal__container {
      min-width: 400px;
    }
  }
}

.input-group {
  display: flex;
  width: 30vw;
  justify-content: space-between;
}

.action {
  margin-top: var(--spacer-base);
  text-align: center;
}

.bottom {
  display: flex;
  flex-direction: column;
  align-items: center;
  &__heading {
    --heading-title-color: var(--c-primary);
    padding: var(--spacer-sm) 0;
  }
  &__close {
    padding-top: var(--spacer-lg);
  }
  &:last-child {
    padding-bottom: var(--spacer-lg);
  }
}

.sf-button--muted {
  color: var(--c-text-muted);
}

.close-button {
  @include for-mobile {
    position: absolute;
    bottom: 0;
    left: 0;
  }
}

.salutation {
  width: 8vw;
}
</style>
